#!/boot/home/config/bin/python

# Written by Bram Cohen
# see LICENSE.txt for license information

# Begin Bethon Stuff
import BApplication
import BFilePanel
from BView import BView
from BStringView import BStringView
from BWindow import BWindow
from BStatusBar import BStatusBar
from BButton import BButton
from BMessage import BMessage
from BMessenger import BMessenger
from BDirectory import BDirectory
from BEntry import BEntry
from BPath import BPath
from BAlert import BAlert 
from BFont import BFont
from BTextView import BTextView
from BMimeType import BMimeType

from InterfaceKit import B_FOLLOW_ALL,B_TITLED_WINDOW,B_WILL_DRAW,B_NOT_RESIZABLE,B_NOT_ZOOMABLE, B_NAVIGABLE,B_FONT_ALL

from StorageKit import B_FILE_NODE,B_DIRECTORY_NODE,B_OPEN_PANEL,B_SAVE_PANEL

from AppKit import B_QUIT_REQUESTED
# End Bethon Stuff

from sys import argv, version
from BitTornado import PSYCO
if PSYCO.psyco:
    try:
        import psyco
        assert psyco.__version__ >= 0x010100f0
        psyco.full()
    except:
        pass
    
from BitTornado.download_bt1 import BT1Download, defaults, parse_params, get_usage, get_response
from BitTornado.RawServer import RawServer, UPnP_ERROR
from random import seed
from socket import error as socketerror
from BitTornado.bencode import bencode
from BitTornado.natpunch import UPnP_test
from threading import Event, Thread
from os.path import abspath
from os.path import join
from os import getcwd
from sys import argv, version, stdout
import sys
from sha import sha
from time import strftime
from BitTornado.clock import clock
from BitTornado import createPeerID
from BitTornado.ConfigDir import ConfigDir

assert version >= '2', "Install Python 2.0 or greater"
try:
    True
except:
    True = 1
    False = 0

from BitTornado import version

UPDATE_TEXT = 500

PROFILER = False

def hours(n):
    if n == 0:
        return 'complete!'
    try:
        n = int(n)
        assert n >= 0 and n < 5184000  # 60 days
    except:
        return '<unknown>'
    m, s = divmod(n, 60)
    h, m = divmod(m, 60)
    if h > 0:
        return '%d hour %02d min %02d sec' % (h, m, s)
    else:
        return '%d min %02d sec' % (m, s)

class DownloadInfoFrame(BWindow):
	def __init__(self, flag):
		BWindow.__init__(self, (10, 30, 460, 260), 'BitTorrent ' + version + ' download',
			B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
		
		self.flag = flag
		self.fin = False
		self.ofFlag = False
		self.ofPath = ''
		self.f = None
			
		# Main View
		self.view = BView((0,0,450,230), 'btMainView',
			B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.SetViewColor((216,216,216,0))
		self.AddChild(self.view)

		font = self.view.GetFont()		
		fontHeight = font.GetHeight()
		height = float(int(fontHeight[0] + fontHeight[1] + fontHeight[2] + 0.5)) + 1.0
		
		left = 10
		right = 440
		top = 10
		column2 = 80
		column4 = right - 55
		column3 = column4 - 65

		# File Name
		bottom = top + height
		self.fileNameLabel = BStringView((left,top,left+35,bottom),'nameLabel', 'name:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.fileNameLabel)
		self.fileNameText = BStringView((left+40,top,right,bottom),'nameView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.fileNameText)

		# Destination file
		top = bottom + 1
		bottom = top + height
		self.fileDestText = BStringView((left,top,right,bottom), 'fileDestView', '', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.fileDestText)

		# Progress Indicator
		top = bottom + 1
		self.gauge = BStatusBar((left,top,right,2), 'btStatusBar', '0%', '100%')
		self.gauge.SetMaxValue(float(1000))
		self.view.AddChild(self.gauge)
		bounds = self.gauge.Bounds()
		bottom = top + bounds[3]
		
		# Estimated time left & Active Bar
		top = bottom + 1
		bottom = top + height
		self.timeEstLabel = BStringView((left,top,125,bottom), 'timeEstLabel', 'Estimated time left:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.timeEstLabel)
		self.timeEstText = BStringView((130,top,290,bottom), 'timeEstView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.timeEstText)

		self.activeBar = BStatusBar((column4+5,top-height,right,bottom), 'activeBarView')
		self.activeBar.SetBarHeight(height-1)
		self.activeBar.SetBarColor((255,88,88,0))
		self.activeBar.SetMaxValue(float(100))
		self.view.AddChild(self.activeBar)
		self.direction = 'right'

		# Share Rating
		top = bottom + 1
		bottom = top + height
		self.shareRatingLabel = BStringView((left,top,column2,bottom), 'shareRatingLabel', 'Share rating:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.shareRatingLabel)
		self.shareRatingText = BStringView((column2+5,top,right,bottom), 'shareRatingView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.shareRatingText)

		# Seed Status & Download Rate
		top = bottom + 1
		bottom = top + height
		self.seedStatusLabel = BStringView((left,top,column2,bottom), 'seedStatusLabel', 'Seed status:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.seedStatusLabel)
		self.seedStatusText = BStringView((column2+5,top,column3,bottom), 'seedStatusView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.seedStatusText)

		self.downRateLabel = BStringView((column3+5,top,column4,bottom), 'downRateLabel', 'Download:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.downRateLabel)
		self.downRateText = BStringView((column4+5,top,right,bottom), 'downRateView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.downRateText)

		# Peer Status & Upload Rate
		top = bottom + 1
		bottom = top + height
		self.peerStatusLabel = BStringView((left,top,column2,bottom), 'peerStatusLabel', 'Peer status:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.peerStatusLabel)
		self.peerStatusText = BStringView((column2+5,top,column3,bottom), 'peerStatusView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.peerStatusText)

		self.upRateLabel = BStringView((column3+5,top,column4,bottom), 'upRateLabel', 'Upload:', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.upRateLabel)
		self.upRateText = BStringView((column4+5,top,right,bottom), 'upRateView', 'n/a', B_FOLLOW_ALL, B_WILL_DRAW)
		self.view.AddChild(self.upRateText)

		# Error area
		top = bottom + 1
		bounds = self.Bounds()
		bottom = bounds[3] - 40
		textBottom = bottom - top - 1
		self.errorText = BTextView((left,top,right,bottom), 'errorView', (1,1, 389,textBottom), B_FOLLOW_ALL, B_WILL_DRAW)
		self.errorText.SetFontAndColor(self.view.GetFont(), B_FONT_ALL, (255,0,0,0))
		self.errorText.SetViewColor((216,216,216,0))  
		self.view.AddChild(self.errorText)

		# Cancel button
		top = bottom + 5
		bottom = 220
		width = 80
		center = (right - left) / 2
		self.cancelButton = BButton((center - width/2, top, center + width/2, bottom), 'cancelButtonView', 'Cancel', BMessage(B_QUIT_REQUESTED))
		self.view.AddChild(self.cancelButton)
		
	def chooseFile(self, default, size, saveas, dir):
		self.f = Event()
		bucket = [None]
		msg = BMessage(1)
		msg.AddString('default', default)
		msg.AddFloat('size', float(size))
		messenger = BMessenger(self)
		dl = BFilePanel.BFilePanel(B_OPEN_PANEL,messenger,None,B_FILE_NODE|B_DIRECTORY_NODE,0,msg,None,0,1)
		dl.SetPanelDirectory('/boot/home')
		dl.Show()
		self.f.wait()
		self.Lock()
		self.fileDestText.SetText('%s' % (self.ofPath))
		self.Unlock()		
		bucket[0] = self.ofPath
		if bucket[0] == '':
			self.done(None)
		return bucket[0]

	def updateStatus(self, fractionDone=None, timeEst=None, downRate=None, upRate=None, activity=None, statistics = None,  **kws):
		self.Lock()	
		self.BeginViewTransaction() # doesn't really seem to help against flicker
		if fractionDone is not None and not self.fin:
			self.gauge.Update(float(fractionDone * 1000)-self.gauge.CurrentValue())
			self.SetTitle('%d%% %s - BitTorrent %s' % (int(fractionDone*100), self.filename, version))
		if timeEst is not None:
			self.timeEstText.SetText('%s' % (hours(timeEst)))
		if activity is not None and not self.fin:    
			self.timeEstText.SetText('%s' % (activity))
		if downRate is not None:
			self.downRateText.SetText('%.0f kB/s' % (float(downRate) / (1 << 10)))
		if upRate is not None:
			self.upRateText.SetText('%.0f kB/s' % (float(upRate) / (1 << 10)))
		if statistics is not None:
			if (statistics.shareRating < 0) or (statistics.shareRating > 100):
				self.shareRatingText.SetText('oo  (%.1f MB up / %.1f MB down)' % (float(statistics.upTotal) / (1<<20), float(statistics.downTotal) / (1<<20)))
			else:
				self.shareRatingText.SetText('%.3f  (%.1f MB up / %.1f MB down)' % (statistics.shareRating, float(statistics.upTotal) / (1<<20), float(statistics.downTotal) / (1<<20)))
			if not self.fin:
				self.seedStatusText.SetText('%d seen now, plus %.3f distributed copies' % (statistics.numSeeds,0.001*int(1000*statistics.numCopies)))
			else:
				self.seedStatusText.SetText('%d seen, plus %.3f distributed copies' % (statistics.numOldSeeds,0.001*int(1000*statistics.numCopies)))
			self.peerStatusText.SetText('%d seen now, %.1f%% done at %.1f kB/s' % (statistics.numPeers,statistics.percentDone,float(statistics.torrentRate) / (1 << 10)))

		steps = 4
		step = float(100)/steps
		if self.direction is 'right':
			self.activeBar.Update(float(step))
		if self.direction is 'left':
			self.activeBar.Update(float(-step))
		if (round(self.activeBar.CurrentValue()) <= 0):
			self.direction = 'right'
		if (round(self.activeBar.CurrentValue()) >= 100):
			self.direction = 'left'
		self.UpdateIfNeeded()      # doesn't really seem to help against flicker
		self.EndViewTransaction()  # doesn't really seem to help against flicker
		self.Unlock()
		
	def finishEvent(self):
		self.Lock()
		self.timeEstText.SetText('Download Succeeded!')
		self.cancelButton.SetLabel('Finish')
		self.gauge.Reset('0%', '100%')
		self.gauge.SetMaxValue(float(1000))
		self.SetTitle('%s - Upload - BitTorrent %s' % (self.filename, version))
		self.downRateText.SetText('done.')
		self.Unlock()

	def finished(self):
		self.fin = True
		self.finishEvent()

	def errorEvent(self, errormsg):
		self.Lock()
		self.errorText.SetText(strftime('ERROR (%I:%M %p) -\n') + errormsg)
		self.Unlock()
		
	def error(self, errormsg):
		self.errorEvent(errormsg)

	def failEvent(self):
		self.Lock()
		self.timeEstText.SetText('n/a')
		self.cancelButton.SetLabel('Close')
		self.gauge.SetBarColor((255,0,0,0))  
		self.activeBar.Update(-self.activeBar.CurrentValue())
		self.downRateText.SetText('failed.')
		self.Unlock()
		
	def failed(self):
		self.fin = True
		self.failEvent()

	def newpath(self, path):
		self.Lock()
		self.fileDestText.SetText('%s' % (path))
		self.Unlock()
	
	def MessageReceived(self, msg):
		if msg.what == 1:
			ref = msg.FindRef('refs')
			default = msg.FindString('default')
			size = msg.FindFloat('size')
			
			entry = BEntry(ref, True)
			path = entry.GetPath()
			
			self.ofPath = path.Path() + '/' + default
			
			self.ofFlag = True
			self.filename = default
			
			self.Lock()			
			self.fileNameText.SetText('%s (%.1f MB)' % (default, float(size) / (1 << 20)))	
			self.timeEstText.SetText('Starting up...')
			self.Unlock()
			
			self.SetTitle(default + ' - BitTorrent ' + version)

		if msg.what == 1598246467:
#			if self.ofFlag == False:
#				self.ofFlag = True
#				self.done(None)
			self.f.set()				
	
	def done(self, event):
		self.flag.set()
				
	def QuitRequested(self):
		#  QuitRequested() is a Be API "hook" that BeOS can
		#  call because this class instance "bound" itself to
		#  the BWindow.
		self.flag.set()
		self.fin = True
		BApplication.be_app.PostMessage(B_QUIT_REQUESTED)
		
		return 1

class btBeApp(BApplication.BApplication):
	def __init__(self, params):
		self.params = params
		BApplication.BApplication.__init__(self, "application/x-vnd.bachmann.BitTornado-BeOS")
		
	def ReadyToRun(self):
		# Install BitTorrent mime type		
		mime = BMimeType('application/x-bittorrent')
		
		if mime.IsInstalled() == False:
			mime.Install()
			mime.SetShortDescription('BitTorrent File')
			mime.SetLongDescription('BitTorrent File')
			mime.SetPreferredApp('application/x-vnd.bachmann.BitTornado-BeOS')
			msg = BMessage()
			msg.AddString('extensions', 'torrent')
			mime.SetFileExtensions(msg)
			mime.SetSnifferRule("1.0 ('d8:announce')")
			
		doneflag = Event()
		d = DownloadInfoFrame(doneflag)
		d.Show()
		thread = Thread(target = next, args = [self, d, doneflag])
		thread.setDaemon(False)
		thread.start()
		
#	def ArgvReceived(self, argv):
		# Here we get a tuple and it looks we must convert it to a list, so we do that.
#		self.params = [x for x in argv[2:]]

	def RefsReceived(self, msg):
		ref = msg.FindRef('refs')
		
		entry = BEntry(ref, True)
		path = entry.GetPath()
		
		self.params = [path.Path()]

def next(self, d, doneflag):
    while 1:
        configdir = ConfigDir('BitTornado-BeOS')
        defaultsToIgnore = ['responsefile', 'url', 'priority']
        configdir.setDefaults(defaults,defaultsToIgnore)
        configdefaults = configdir.loadConfig()
        defaults.append(('save_options',0,
         "whether to save the current options as the new default configuration " +
         "(only for BitTornado-BeOS.py)"))
        try:
            config = parse_params(self.params, configdefaults)
        except ValueError, e:
            print 'error: ' + str(e) + '\nrun with no args for parameter explanations'
            break
        if not config:
            print get_usage(defaults, 100, configdefaults)
            break
        if config['save_options']:
            configdir.saveConfig(config)
        configdir.deleteOldCacheData(config['expire_cache_data'])

        myid = createPeerID()
        seed(myid)
        
        def disp_exception(text):
            print text
        rawserver = RawServer(doneflag, config['timeout_check_interval'],
                              config['timeout'], ipv6_enable = config['ipv6_enabled'],
                              failfunc = d.failed, errorfunc = disp_exception)
        upnp_type = UPnP_test(config['upnp_nat_access'])
        while True:
            try:
                listen_port = rawserver.find_and_bind(config['minport'], config['maxport'],
                                config['bind'], ipv6_socket_style = config['ipv6_binds_v4'],
                                upnp = upnp_type, randomizer = config['random_port'])
                break
            except socketerror, e:
                if upnp_type and e == UPnP_ERROR:
                    print 'WARNING: COULD NOT FORWARD VIA UPnP'
                    upnp_type = 0
                    continue
                print "error: Couldn't listen - " + str(e)
                d.failed()
                return

        response = get_response(config['responsefile'], config['url'], d.error)
        if not response:
            break

        infohash = sha(bencode(response['info'])).digest()

        dow = BT1Download(d.updateStatus, d.finished, d.error, disp_exception, doneflag,
                        config, response, infohash, myid, rawserver, listen_port,
                        configdir)
        
        if not dow.saveAs(d.chooseFile, d.newpath):
            break

        if not dow.initFiles(old_style = True):
            break
        if not dow.startEngine():
            dow.shutdown()
            break
        dow.startRerequester()
        dow.autoStats()

        if not dow.am_I_finished():
            d.updateStatus(activity = 'connecting to peers')
        rawserver.listen_forever(dow.getPortHandler())
        d.updateStatus(activity = 'shutting down')
        dow.shutdown()
        break
    try:
        rawserver.shutdown()
    except:
        pass
    if not d.fin:
        d.failed()

def run(params):
	app = btBeApp(params)
	app.Run()	

if __name__ == '__main__':
    if argv[1:] == ['--version']:
        print version
        sys.exit(0)

    if PROFILER:
        import profile, pstats
        p = profile.Profile()
        p.runcall(run, argv[1:])
        log = open('profile_data.'+strftime('%y%m%d%H%M%S')+'.txt','a')
        normalstdout = sys.stdout
        sys.stdout = log
#        pstats.Stats(p).strip_dirs().sort_stats('cumulative').print_stats()
        pstats.Stats(p).strip_dirs().sort_stats('time').print_stats()
        sys.stdout = normalstdout
    else:
        run(argv[1:])
